<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ignore_user_abort(true);
set_time_limit(0);
include 'functions.php';
$skipCustomer = array("DECLINED","REFUNDED","CANCELLED");

$failed = array();
$success = array();
$eixsingoffers = array(116,117);
$tomorrow_date = date("Y-m-d");
$notDoneCustomers = get_all_champ_orders_ids(5,$tomorrow_date);
// echo "<pre>";
// print_r($notDoneCustomers);
// exit;
$processOrder = array();
foreach ($notDoneCustomers as $cust){
    if(empty($cust['customer_id'])){
        continue;
    }
    $customer_id = $cust['customer_id'];
    $customer_orders = get_order($customer_id);
    $is_process_order = false;

    if(!empty($customer_orders['result']) && $customer_orders['result'] == 'SUCCESS'){
        $orders = !empty($customer_orders['message']['data'])?$customer_orders['message']['data']:array();
        $customer_history = customerHistory($customer_id);
        if($customer_history['status']){
            foreach ($orders as $order){

                if(!in_array($order['orderStatus'],$skipCustomer)){
                    $items = $order['items'];
                    foreach ($items as $key => $value){
                        if(!in_array($key,$eixsingoffers)){
                            $is_process_order=true;
                            $purchase_id = $value['purchaseId'];
                            if(!empty($cust['nextBillDate'])){
                                $nextBillingDate = $cust['nextBillDate'];
                            } else {
                                $nextBillingDate = $value['nextBillDate'];
                            }
                            $nextBillingDate = '2024-07-06';
                            $product_id = 87;
                        }else{
                            $is_process_order=false;
                            break;
                        }
                    }
                } else {
                    $failed[$cust['id']] = $order['orderStatus'];
                }
            }
        } else {
            $failed[$cust['id']] = $customer_history['reason'];
        }

        if(!empty($is_process_order)){
            $processOrder[$cust['id']] = $customer_id;
        }
    }
}
if(!empty($processOrder)){
    foreach ($processOrder as $key => $customer){
        $response = addNewOffer($customer);
        $success[$key] = $response;
    }
}

foreach ($success as $key=>$value){
    $updatedata = array();
    $id = $key;
    $updatedata['is_processed'] = 1;

    if(!empty($value['result']) && $value['result'] == 'SUCCESS'){
        $updatedata['is_success'] = 1;
    } else {
        $updatedata['is_success'] = 0;
    }
    $updatedata['response'] = json_encode($value);
    if(!empty($updatedata)){
        update_order_by_id('champ_customers',$updatedata,$id);
    }
}
foreach ($failed as $key=>$value){
    $updatedata = array();
    $id = $key;
    if(!empty($value)){
        $updatedata['reason'] = $value;
    }
    $updatedata['is_processed'] = 1;
    $updatedata['is_success'] = 0;
    if(!empty($updatedata)){
        update_order_by_id('champ_customers',$updatedata,$id);
    }
}
echo "completed.............................";

exit;