<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ignore_user_abort(true);
set_time_limit(0);
include 'functions.php';
$skipCustomer = array("REFUNDED", "BLACKLISTED", "CHARGEBACKED", "ORDER_CANCELLED");

// ADD CUSTOMER IDS HERE
// TURN OFF SHOPIFY PLUGINS ALSO!
//$notDoneCustomerIDs = array("7694","5604","7682","7388","7680","7672","7671","7669","7660","7658","7657","7652","7648","7649","7643","7642","4660","4655","4644","4604","4600","1543","1439");
//7695,7679
// $date = "2024-05-30";
$date = date('Y-m-d');
$notDoneCustomerIDs = get_all_orders_ids(50);


// Display not done customer IDs (you can process them as needed)

$success = array();

foreach ($notDoneCustomerIDs as $offer) {
    $orderData = [];
    $orderData['previousOrderId'] = $offer['orderId'];
    $orderData['shippingId'] = 2;
    // $orderData['ipAddress'] = get_client_ip();
    $orderData['campaignId'] = 12;
    $orderData['offers'][0]['offer_id'] = 12;
    $orderData['offers'][0]['product_id'] = 1686;
    $orderData['offers'][0]['billing_model_id'] = 3;
    $orderData['offers'][0]['quantity'] = 1;
    $orderData['offers'][0]['trial']['product_id'] = 1686;
    $upsellResponse = addUpSell($orderData);
    $success[$offer['id']] = array("kk_post_data" => $orderData, "response" => $upsellResponse);
}
// echo "<pre>";
// print_r($success);
// exit;

foreach ($success as $key => $value) {

    $updatedata = array();
    $id = $key;
    $updatedata['is_processed'] = 1;
    $updatedata['is_upsell_created'] = 1;
    $updatedata['kk_post_data'] = json_encode($value['kk_post_data']);
    $updatedata['response'] = $value['response'];
    $response = $value['response'];
    if (!empty($response)) {
        $response = json_decode($response, true);
        if (!empty($response['response_code']) && $response['error_found'] == '0' && $response['response_code'] == '100') {
            $updatedata['is_success'] = 1;
            $updatedata['is_upsell_success'] = 1;
            $updatedata['newOrderId'] = $response['order_id'];
        } else {
            $updatedata['is_success'] = 0;
        }
    } else {
        $updatedata['is_success'] = 0;
    }


    if (!empty($updatedata)) {

        update_customer_order('sticky_customers', $updatedata, $id);
    }
}

echo "completed.............................";
exit;
