<?php 
$log_file = '/home/wbhkshp/public_html/importOrder/puppy_cron_log.txt';
//$log_file = 'log/puppy_cron_log.txt';
$current_time = date('Y-m-d H:i:s');
file_put_contents($log_file, "Cron job executed at: $current_time\n", FILE_APPEND);

$timezone = new DateTimeZone('America/New_York');
$datetime = new DateTime('now', $timezone);
$datetime->modify('-1 hour');
// 2 HOURS AGO
$startDate = $datetime->format('n/j/y');
$startTime = $datetime->format('H:i');
//NOW
$datetimenow = new DateTime('now', $timezone);
$endDate = $datetimenow->format('n/j/y'); //date("Y-m-d H:i:s");
$endTime = $datetimenow->format('H:i');


//file_put_contents($log_file, "$startDate\n$startTime\n$endDate\n$endTime\n", FILE_APPEND);

$loginId = "yuriiapi2";
$password = "yuriiapi2";
$orderStatus = "COMPLETE";
$orderType = "NEW_SALE";
$orderId = "93144044EC";
// $orderId = "8897B4C477";
// $warrantyId = 118;
// $warranty2Id = 119;
$failed = array();
$success = array();
$offersList = array(157,158, 162, 414);
$skipCustomer = array("DECLINED","REFUNDED","CANCELLED");
//APIs
$order_query_link = "https://api.checkoutchamp.com/order/query/";
$import_upsell_link = "https://api.checkoutchamp.com/upsale/import/";
$import_order_link = "https://api.checkoutchamp.com/order/import/";
$customer_history_link = "https://api.checkoutchamp.com/customer/history/?loginId=yuriiapi2&password=yuriiapi2&customerId=";

function get_checkoutchamp_orders($order_query_link, $loginId, $password, $orderId, $orderStatus, $orderType, $startDate, $endDate, $startTime, $endTime)
{
$curl = curl_init();
// Set cURL options
    curl_setopt_array($curl, array(
        //CURLOPT_URL => "$order_query_link?loginId=$loginId&password=$password&orderId=$orderId",
        CURLOPT_URL => "$order_query_link?loginId=$loginId&password=$password&orderStatus=$orderStatus&orderType=$orderType&startDate=$startDate&endDate=$endDate&startTime=$startTime&endTime=$endTime&resultsPerPage=200",
        CURLOPT_RETURNTRANSFER => true, // Return the response as a string instead of outputting it
        CURLOPT_HEADER => false, // Exclude the header from the output
    ));
    $response = curl_exec($curl);
    //file_put_contents('log/cron_log.txt', "dsa: $response \n", FILE_APPEND);
    curl_close($curl);
    $json_data = json_decode($response, true);
    if ($json_data === null) {
        // JSON decoding error occurred
        $error_msg = json_last_error_msg();
        echo "JSON decoding error: $error_msg";
    }
    return $json_data;
}
function getChampCustomerHistory($customer_history_link, $customerId){
    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => $customer_history_link.$customerId,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);
    curl_close($curl);
    return  json_decode($response,true);
}
function get_orders_by_customer($order_query_link, $loginId, $password, $customerId)
{
$curl = curl_init();
// Set cURL options
    curl_setopt_array($curl, array(
        CURLOPT_URL => "$order_query_link?loginId=$loginId&password=$password&customerId=$customerId",
        //CURLOPT_URL => "$order_query_link?loginId=$loginId&password=$password&orderStatus=$orderStatus&orderType=$orderType&startDate=$startDate&endDate=$endDate&startTime=$startTime&endTime=$endTime&resultsPerPage=200",
        CURLOPT_RETURNTRANSFER => true, // Return the response as a string instead of outputting it
        CURLOPT_HEADER => false, // Exclude the header from the output
    ));
    $response = curl_exec($curl);
    // file_put_contents('log/cron_log.txt', "dsa: $response \n", FILE_APPEND);
    curl_close($curl);
    $json_data = json_decode($response, true);
    if ($json_data === null) {
        // JSON decoding error occurred
        $error_msg = json_last_error_msg();
        echo "JSON decoding error2: $error_msg";
    }
    return $json_data;
}
function import_upsell($import_upsell_link, $orderId, $loginId, $warrantyId){
    $curl = curl_init();

    // Set cURL options
        curl_setopt_array($curl, array(
            //CURLOPT_URL => "$import_upsell_link?loginId=$loginId&password=yuriiapi2&orderId=$orderId&productId=$warrantyId",
            CURLOPT_RETURNTRANSFER => true, // Return the response as a string instead of outputting it
            CURLOPT_HEADER => false, // Exclude the header from the output
        ));
        // $response = curl_exec($curl);
        // curl_close($curl);
        // $json_data = json_decode($response, true);

        $response = curl_exec($curl);
        if ($response === false) {
            // Handle curl execution error
            $error = curl_error($curl);
            curl_close($curl);
            return "Curl error: " . $error;
        } else {
            curl_close($curl);
            $json_data = json_decode($response, true);
            return $json_data;
        }
}
 function importOrder($firstName, $lastName, $address1, $address2, $postalCode, $city, $state, $country, $emailAddress, $phoneNumber, 
 $shipFirstName, $shipLastName, $shipAddress1, $shipAddress2, $shipPostalCode, $shipCity, $shipState, $shipCountry, $paySource, $campaignId, $product1_id,
 $product1_qty, $product2_id, $product2_qty, $affId){
    //function importOrder($firstName, $lastName, $address1, $address2, $postalCode, $city, $state, $country, $emailAddress, $phoneNumber, 
    //$shipFirstName, $shipLastName, $shipAddress1, $shipAddress2, $shipPostalCode, $shipCity, $shipState, $shipCountry, $paySource, $campaignId, $product1_id,
    //$product1_qty, $affId){
//    exit;
// Construct the populated URL
    $populatedUrl = "https://api.checkoutchamp.com/order/import/?loginId=yuriiapi2&password=yuriiapi2&firstName=$firstName&lastName=$lastName&address1=$address1&address2=$address2&postalCode=$postalCode&city=$city&state=$state&country=$country&emailAddress=$emailAddress&phoneNumber=$phoneNumber&shipFirstName=$shipFirstName&shipLastName=$shipLastName&shipAddress1=$shipAddress1&shipAddress2=$shipAddress2&shipPostalCode=$shipPostalCode&shipCity=$shipCity&shipState=$shipState&shipCountry=$shipCountry&paySource=$paySource&campaignId=$campaignId&product1_id=$product1_id&product1_qty=$product1_qty&product2_id=$product2_id&product2_qty=$product2_qty&affId=$affId";
    //$populatedUrl = "https://api.checkoutchamp.com/order/import/?loginId=yuriiapi2&password=yuriiapi2&firstName=$firstName&lastName=$lastName&address1=$address1&address2=$address2&postalCode=$postalCode&city=$city&state=$state&country=$country&emailAddress=$emailAddress&phoneNumber=$phoneNumber&shipFirstName=$shipFirstName&shipLastName=$shipLastName&shipAddress1=$shipAddress1&shipAddress2=$shipAddress2&shipPostalCode=$shipPostalCode&shipCity=$shipCity&shipState=$shipState&shipCountry=$shipCountry&paySource=$paySource&campaignId=$campaignId&product1_id=$product1_id&product1_qty=$product1_qty&affId=$affId";

    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => $populatedUrl,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    return json_decode($response,true);
}
function customerHistory($customer_history_link, $customerId){
    $skipCustomer = array("REFUNDED","BLACKLISTED","CHARGEBACKED", "ORDER_CANCELLED");
    $userHistory = getChampCustomerHistory($customer_history_link, $customerId);
    if($userHistory["result"] == "SUCCESS"){
        if(!empty($userHistory["message"]["data"])){
            foreach($userHistory["message"]["data"] as $history){
                if(in_array($history["categoryType"],$skipCustomer) || ($history["categoryType"] == "RECYCLE_FAILED" && strpos($history["message"], "Recycle Attempt #2") !== false)){
                    return array("status"=>false,"reason"=>$history["categoryType"]);
                    exit;
                }
            }
            return array("status"=>true);
        }
    }
}

$orders_response = get_checkoutchamp_orders($order_query_link, $loginId, $password, $orderId, $orderStatus, $orderType, $startDate, $endDate, $startTime, $endTime);
$orders = $orders_response['message']['data'];
// $idList = [];
//foreach ($orders as $getId){
//    // $idList[] = $getId['orderId'];
//    file_put_contents($log_file, "List of orders: ". $getId['orderId']. "\n", FILE_APPEND);
//}
foreach ($orders as $order) {
    if(empty($order['customerId'])){
        continue;
    }
    $customerId = $order['customerId'];
    $customer_orders = get_orders_by_customer($order_query_link, $loginId, $password, $customerId);
    $is_process_order = false;
    echo count($customer_orders['message']['data'])."<br>";
    if(!empty($customer_orders['result']) && $customer_orders['result'] == 'SUCCESS'){
        $orders = !empty($customer_orders['message']['data'])?$customer_orders['message']['data']:array();
        $customer_history = customerHistory($customer_history_link, $customerId);
        if($customer_history['status']){
            foreach ($orders as $order){
                if(!in_array($order['orderStatus'],$skipCustomer)){
                    $items = $order['items'];
                    echo 'orderStatus'.$order['orderStatus']."<br>";
                    foreach ($items as $key => $value){
                        if(!in_array($key,$offersList)){
                            echo "pairs:".$key.$value."<br>";
                            $is_process_order=true;
                        }else{
                            $is_process_order=false;
                            break;
                        }
                    }
                } else {
                    $failed[$order['customerId']] = $order['orderStatus'];
                    echo "failed <br>".$order['customerId'];
                }
            }
        }else {
            $failed[$order['customerId']] = $customer_history['reason'];
        }
        if(!empty($is_process_order)){
            echo "is_process <br>";
            $processOrder = array();
            $processOrder[] = $customerId;
            echo "<pre>dsdcsdc";
            //print_r($order);
            echo "</pre>";
            $firstName = isset($order['firstName']) ? urlencode($order['firstName']) : '';
            $lastName = isset($order['lastName']) ? urlencode($order['lastName']) : '';
            $address1 = isset($order['address1']) ? urlencode($order['address1']) : '';
            $address2 = isset($order['address2']) ? urlencode($order['address2']) : '';
            $postalCode = isset($order['postalCode']) ? urlencode($order['postalCode']) : '';
            $city = isset($order['city']) ? urlencode($order['city']) : '';
            $state = isset($order['state']) ? urlencode($order['state']) : '';
            $country = isset($order['country']) ? urlencode($order['country']) : '';
            $emailAddress = isset($order['emailAddress']) ? urlencode($order['emailAddress']) : '';
            $phoneNumber = isset($order['phoneNumber']) ? urlencode($order['phoneNumber']) : '';
            $shipFirstName = isset($order['shipFirstName']) ? urlencode($order['shipFirstName']) : '';
            $shipLastName = isset($order['shipLastName']) ? urlencode($order['shipLastName']) : '';
            $shipAddress1 = isset($order['shipAddress1']) ? urlencode($order['shipAddress1']) : '';
            $shipAddress2 = isset($order['shipAddress2']) ? urlencode($order['shipAddress2']) : '';
            $shipPostalCode = isset($order['shipPostalCode']) ? urlencode($order['shipPostalCode']) : '';
            $shipCity = isset($order['shipCity']) ? urlencode($order['shipCity']) : '';
            $shipState = isset($order['shipState']) ? urlencode($order['shipState']) : '';
            $shipCountry = isset($order['shipCountry']) ? urlencode($order['shipCountry']) : '';
            $paySource = 'ACCTONFILE';
            $campaignId = '5';
            $product1_id = '157'; // PRODUCT ID
            $product1_qty = '1';
            $product2_id = '414';
            $product2_qty = '1';
            $affId = '';
            if(!empty($processOrder)){
             $response = importOrder($firstName, $lastName, $address1, $address2, $postalCode, $city, $state, $country, $emailAddress, $phoneNumber, 
             $shipFirstName, $shipLastName, $shipAddress1, $shipAddress2, $shipPostalCode, $shipCity, $shipState, $shipCountry, $paySource, $campaignId, $product1_id,
             $product1_qty, $product2_id, $product2_qty, $affId);
            //$response = importOrder($firstName, $lastName, $address1, $address2, $postalCode, $city, $state, $country, $emailAddress, $phoneNumber, 
           //$shipFirstName, $shipLastName, $shipAddress1, $shipAddress2, $shipPostalCode, $shipCity, $shipState, $shipCountry, $paySource, $campaignId, $product1_id,
            //$product1_qty, $affId);
            file_put_contents('/home/wbhkshp/public_html/importOrder/puppy_cron_log.txt', "import Response: ". print_r($response) . "\n", FILE_APPEND);
            }else{
                echo "empty<br>";
            }
            // $response = importOrder($firstName, $lastName, $address1, $address2, $postalCode, $city, $state, $country, $emailAddress, $phoneNumber, 
            // $shipFirstName, $shipLastName, $shipAddress1, $shipAddress2, $shipPostalCode, $shipCity, $shipState, $shipCountry, $paySource, $campaignId, $product1_id,
            // $product1_qty, $product2_id, $product2_qty, $affId);
        }
    }
    
}

if(!empty($processOrder)){
    echo 'not empty<br>';
}else{
    echo "empty<br>";
}

//https://api.checkoutchamp.com/order/query/?loginId=yuriiapi2&password=yuriiapi2&orderStatus=COMPLETE&startDate=06/26/24&endDate=06/27/24&startTime=00:00&endTime=23:59&orderType=NEW_SALE
// function import_upsell($orderId) {
//     echo "Test function called for order ID: $orderId<br>";
// }

?>

<html>
<head>
</head>
<body>

<?php
echo "today + now: ".$startDate."----------". $startTime;
echo "<br>"; 
echo "today-2hours + now-2hours: ".$endDate."----------". $endTime;
echo "<br>";
//echo $orders;
echo '<pre>';
print_r($orders);
echo '</pre>';
echo "123: ".getType($orders_response);
echo '<pre>';
print_r($customer_history);
echo '</pre>';
//echo import_upsell($import_upsell_link, $orderId, $loginId, $password);
?>
</body>
</html>