<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ignore_user_abort(true);
set_time_limit(0);
include 'functions.php';
$skipCustomer = array("REFUNDED","BLACKLISTED","CHARGEBACKED","ORDER_CANCELLED");

// ADD CUSTOMER IDS HERE
// TURN OFF SHOPIFY PLUGINS ALSO!
$notDoneCustomerIDs = array("1647","1646","1645","1642","1617","1976","1972");

// $date = "2024-05-30";
$date = date('Y-m-d');
$notDoneCustomerIDs = get_all_orders_ids($date,5);
//echo "<pre>";
//print_r($notDoneCustomerIDs);
//exit;
// Display not done customer IDs (you can process them as needed)
$failed = array();
$success = array();
foreach ($notDoneCustomerIDs as $customerID) {
    $is_process = true;
    $userHistory = getCustomerHistory($customerID);
//    echo $customerID;
//    echo "<br>";
//    echo "<pre>";
//    print_r($userHistory);
//    exit;
    $reason = "";
    if($userHistory["result"] == "SUCCESS"){
        if(!empty($userHistory["message"]["data"])){
            foreach($userHistory["message"]["data"] as $history){

                if(in_array($history["categoryType"],$skipCustomer) || ($history["categoryType"] == "RECYCLE_FAILED" && strpos($history["message"], "Recycle Attempt #2") !== false)){
                    $is_process = FALSE;
                    $reason = $history["categoryType"];
                    break;
                }

            }
        }
    }

    if(empty($is_process)){
        $failed[$customerID] = $reason;
        continue;
    }
    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://api.konnektive.com/purchase/query/?loginId=farazdev&password=farazdev&customerId=$customerID",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);

    curl_close($curl);



// Decode the JSON response into a PHP array
    $data = json_decode($response, true);
    if(!empty($data['result']) && $data['result'] == 'ERROR'){
        echo "ERROR>>>>>>>>>>> <br>";
        continue;
    }
//echo "<pre>";
//print_r($data);
//exit;
// Extract the relevant data
    $firstName = urlencode($data['message']['data'][0]['firstName']);
    $lastName = urlencode($data['message']['data'][0]['lastName']);
    $address1 = urlencode($data['message']['data'][0]['address1']);
    $address2 = urlencode($data['message']['data'][0]['address2']);
    $postalCode = urlencode($data['message']['data'][0]['postalCode']);
    $city = urlencode($data['message']['data'][0]['city']);
    $state = urlencode($data['message']['data'][0]['state']);
    $country = urlencode($data['message']['data'][0]['country']);
    $emailAddress = urlencode($data['message']['data'][0]['emailAddress']);
    $phoneNumber = urlencode($data['message']['data'][0]['phoneNumber']);
    $shipFirstName = urlencode($data['message']['data'][0]['shipFirstName']);
    $shipLastName = urlencode($data['message']['data'][0]['shipLastName']);
    $shipAddress1 = urlencode($data['message']['data'][0]['shipAddress1']);
    $shipAddress2 = urlencode($data['message']['data'][0]['shipAddress2']);
    $shipPostalCode = urlencode($data['message']['data'][0]['shipPostalCode']);
    $shipCity = urlencode($data['message']['data'][0]['shipCity']);
    $shipState = urlencode($data['message']['data'][0]['shipState']);
    $shipCountry = urlencode($data['message']['data'][0]['shipCountry']);
    $paySource = 'ACCTONFILE';
    $campaignId = '11';
    $product1_id = '116'; // PRODUCT ID
    $product1_qty = '1';
    $affId = '';
    //exit;
// Construct the populated URL
    $populatedUrl = "https://api.konnektive.com/order/import/?loginId=farazdev&password=farazdev&firstName=$firstName&lastName=$lastName&address1=$address1&address2=$address2&postalCode=$postalCode&city=$city&state=$state&country=$country&emailAddress=$emailAddress&phoneNumber=$phoneNumber&shipFirstName=$shipFirstName&shipLastName=$shipLastName&shipAddress1=$shipAddress1&shipAddress2=$shipAddress2&shipPostalCode=$shipPostalCode&shipCity=$shipCity&shipState=$shipState&shipCountry=$shipCountry&paySource=$paySource&campaignId=$campaignId&product1_id=$product1_id&product1_qty=$product1_qty&affId=$affId";

//echo $populatedUrl;exit;

    $curl = curl_init();

    curl_setopt_array($curl, array(
        CURLOPT_URL => $populatedUrl,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
    ));

    $response = curl_exec($curl);
    $json_decode = json_decode($response,true);
    curl_close($curl);
    $success[$customerID] = $json_decode;

}
foreach ($success as $key=>$value){
    $updatedata = array();
    $customer_id = $key;
    $updatedata['is_processed'] = 1;

    if(!empty($value['result']) && $value['result'] == 'SUCCESS'){
        $updatedata['is_success'] = 1;
    } else {
        $updatedata['is_success'] = 0;
    }
    $updatedata['response'] = json_encode($value);
    if(!empty($updatedata)){
        update_customer_order('customers',$updatedata,$customer_id);
    }
}
foreach ($failed as $key=>$value){
    $updatedata = array();
    $customer_id = $key;
    if(!empty($value)){
        $updatedata['reason'] = $value;
    }
    $updatedata['is_processed'] = 1;
    $updatedata['is_success'] = 0;
    if(!empty($updatedata)){
        update_customer_order('customers',$updatedata,$customer_id);
    }
}
echo "completed.............................";

exit;

?>