<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ignore_user_abort(true);
set_time_limit(0);
include 'functions.php';
$skipCustomer = array("PARTIAL","DECLINED","REFUNDED","CANCELLED");

$failed = array();
$success = array();
$tomorrow_date = date("Y-m-d", strtotime("+1 day"));
$notDoneCustomers = get_all_champ_orders_ids(5);
//echo "<pre>";
//print_r($notDoneCustomers);
//exit;

foreach ($notDoneCustomers as $cust){
    if(empty($cust['customer_id'])){
        continue;
    }
    $customer_id = $cust['customer_id'];
    $customer_orders = get_order($customer_id);
    if(!empty($customer_orders['result']) && $customer_orders['result'] == 'SUCCESS'){
        $orders = !empty($customer_orders['message']['data'])?$customer_orders['message']['data']:array();
        $customer_history = customerHistory($customer_id);
        if($customer_history['status']){
//         echo "<pre>";
//         print_r($orders);
//         exit;
            foreach ($orders as $order){
                if(!in_array($order['orderStatus'],$skipCustomer)){
                    $items = $order['items'];
                    foreach ($items as $key => $value){
                        if($key == 87 && !empty($value['purchaseId'])){
                            $purchase_id = $value['purchaseId'];
                            if(!empty($cust['nextBillDate'])){
                                $nextBillingDate = $cust['nextBillDate'];
                            } else {
                                 $nextBillingDate = $value['nextBillDate'];
                            }

                            $product_id = 117;
//                            $response_update = '{
//  "result": "SUCCESS",
//  "message": ""
//}';
                        //    $response_update  = json_decode($response_update,true);
                     $response_update = update_purchase($purchase_id,$product_id,$nextBillingDate);
//                  echo "<pre>";
//                  print_r($response_update);
//                  exit;
                            $success[$cust['id']] = $response_update;
                        }
                    }
                } else {
                    $failed[$cust['id']] = $order['orderStatus'];
                }
            }
        } else {
            $failed[$cust['id']] = $customer_history['reason'];
        }
    }
}


foreach ($success as $key=>$value){
    $updatedata = array();
    $id = $key;
    $updatedata['is_processed'] = 1;

    if(!empty($value['result']) && $value['result'] == 'SUCCESS'){
        $updatedata['is_success'] = 1;
    } else {
        $updatedata['is_success'] = 0;
    }
    $updatedata['response'] = json_encode($value);
    if(!empty($updatedata)){
        update_order_by_id('champ_customers',$updatedata,$id);
    }
}
foreach ($failed as $key=>$value){
    $updatedata = array();
    $id = $key;
    if(!empty($value)){
        $updatedata['reason'] = $value;
    }
    $updatedata['is_processed'] = 1;
    $updatedata['is_success'] = 0;
    if(!empty($updatedata)){
        update_order_by_id('champ_customers',$updatedata,$id);
    }
}
echo "completed.............................";

exit;